Module AIOWDM

    Public Const WDG_ACTION_IGNORE As UInt32 = 0
    Public Const WDG_ACTION_DISABLE As UInt32 = 1
    Public Const WDG_ACTION_SOFT_RESTART As UInt32 = 2
    Public Const WDG_ACTION_MOSTLY_SOFT_RESTART As UInt32 = 4
    Public Const PCI_WDG_CSM_RATE As Double = 2.08333
    Public Const P104_WDG_CSM_RATE As Double = 2.08333
    Public Const ISA_WDG_CSM_RATE As Double = 0.894886

    Public Declare Function GetNumCards Lib "AIOWDM" Alias "VBGetNumCards" () As UInt32
    Public Declare Function QueryCardInfo Lib "AIOWDM" Alias "VBQueryCardInfo" (ByVal Cardnum As UInt32, ByRef pDeviceID As UInt32, ByRef pBase As UInt32, ByRef pNameSize As UInt32, ByVal pName As String) As UInt32
    Public Declare Function QueryBARBase Lib "AIOWDM.dll" Alias "VBQueryBARBase" (ByVal CardNum As UInt32, ByVal BARIndex As UInt32, ByRef pBase As UInt32) As UInt32
    Public Declare Function WaitForIRQ Lib "AIOWDM" Alias "VBWaitForIRQ" (ByVal Cardnum As UInt32) As UInt32
    Public Declare Function AbortRequest Lib "AIOWDM" Alias "VBAbortRequest" (ByVal Cardnum As UInt32) As UInt32
    Public Declare Function CloseCard Lib "AIOWDM" Alias "VBCloseCard" (ByVal Cardnum As UInt32) As UInt32
    Public Declare Function COSWaitForIRQ Lib "AIOWDM" Alias "VBCOSWaitForIRQ" (ByVal Cardnum As UInt32, ByVal PPIs As UInt32, ByRef pData As Byte) As UInt32
    Public Declare Function SetCOSScheme Lib "AIOWDM" Alias "VBSetCOSScheme" (ByVal CardNum As UInt32, ByVal COSScheme As UInt32) As UInt32
    Public Declare Function WDGInit Lib "AIOWDM" Alias "VBWDGInit" (ByVal Cardnum As UInt32) As UInt32
    Public Declare Function WDGHandleIRQ Lib "AIOWDM" Alias "VBWDGHandleIRQ" (ByVal Cardnum As UInt32, Action As UInt32) As UInt32
    Public Declare Function WDGSetTimeout Lib "AIOWDM" Alias "VBWDGSetTimeout" (ByVal Cardnum As UInt32, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double
    Public Declare Function WDGPet Lib "AIOWDM" Alias "VBWDGPet" (ByVal Cardnum As UInt32) As UInt32
    Public Declare Function WDGReadTemp Lib "AIOWDM" Alias "VBWDGReadTemp" (ByVal Cardnum As UInt32) As Double
    Public Declare Function WDGReadStatus Lib "AIOWDM" Alias "VBWDGReadStatus" (ByVal Cardnum As UInt32) As UInt32
    Public Declare Function WDGStart Lib "AIOWDM" Alias "VBWDGStart" (ByVal Cardnum As UInt32) As UInt32
    Public Declare Function WDGStop Lib "AIOWDM" Alias "VBWDGStop" (ByVal Cardnum As UInt32) As UInt32
    Public Declare Function EmergencyReboot Lib "AIOWDM" Alias "VBEmergencyReboot" () As UInt32
    Public Declare Function WDGSetResetDuration Lib "AIOWDM" Alias "VBWDGSetResetDuration" (ByVal Cardnum As UInt32, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double

    '8-bit Relative
    Public Declare Function RelInPortB Lib "AIOWDM" Alias "VBRelInPortB" (ByVal Cardnum As UInt32, Port As UInt32) As UInt16
    Public Declare Function RelOutPortB Lib "AIOWDM" Alias "VBRelOutPortB" (ByVal Cardnum As UInt32, Port As UInt32, Value As Byte) As UInt16
    Public Declare Function RelINSB Lib "AIOWDM" Alias "VBRelINSB" (ByVal CardNum As UInt32, ByVal Offset As UInt32, ByVal Count As UInt32, ByRef pBuf As Byte) As UInt32

    '16-bit Relative
    Public Declare Function RelInPort Lib "AIOWDM" Alias "VBRelInPort" (ByVal Cardnum As UInt32, Port As UInt32) As UInt16
    Public Declare Function RelOutPort Lib "AIOWDM" Alias "VBRelOutPort" (ByVal Cardnum As UInt32, Port As UInt32, Value As UInt16) As UInt16
    Public Declare Function RelINSW Lib "AIOWDM" Alias "VBRelINSW" (ByVal CardNum As UInt32, ByVal Offset As UInt32, ByVal Count As UInt32, ByRef pBuf As UInt16) As UInt32

    '32-bit Relative
    Public Declare Function RelInPortL Lib "AIOWDM" Alias "VBRelInPortL" (ByVal Cardnum As UInt32, Port As UInt32) As UInt32
    Public Declare Function RelOutPortL Lib "AIOWDM" Alias "VBRelOutPortL" (ByVal Cardnum As UInt32, Port As UInt32, Value As UInt32) As UInt16
    Public Declare Function RelINSL Lib "AIOWDM" Alias "VBRelINSL" (ByVal CardNum As UInt32, ByVal Offset As UInt32, ByVal Count As UInt32, ByRef pBuf As UInt32) As UInt32
    Public Declare Function RelInPortDWord Lib "AIOWDM" Alias "VBRelInPortDWord" (ByVal Cardnum As UInt32, Port As UInt32) As UInt32
    Public Declare Function RelOutPortDWord Lib "AIOWDM" Alias "VBRelOutPortDWord" (ByVal Cardnum As UInt32, Port As UInt32, Value As UInt32) As UInt16

    '8-bit Absolute
    Public Declare Function InPortB Lib "AIOWDM" Alias "VBInPortB" (ByVal Port As UInt32) As UInt16
    Public Declare Function OutPortB Lib "AIOWDM" Alias "VBOutPortB" (ByVal Port As UInt32, Value As Byte) As UInt16
    Public Declare Function INSB Lib "AIOWDM" Alias "VBINSB" (Addr As UInt32, ByVal Count As UInt32, ByRef pBuf As Byte) As UInt32

    '16-bit Absolute
    Public Declare Function InPort Lib "AIOWDM" Alias "VBInPort" (ByVal Port As UInt32) As UInt16
    Public Declare Function OutPort Lib "AIOWDM" Alias "VBOutPort" (ByVal Port As UInt32, Value As UInt16) As UInt16
    Public Declare Function INSW Lib "AIOWDM" Alias "VBINSW" (Addr As UInt32, ByVal Count As UInt32, ByRef pBuf As UInt16) As UInt32

    '32-bit Absolute
    Public Declare Function InPortL Lib "AIOWDM" Alias "VBInPortL" (ByVal Port As UInt32) As UInt32
    Public Declare Function OutPortL Lib "AIOWDM" Alias "VBOutPortL" (ByVal Port As UInt32, Value As UInt32) As UInt16
    Public Declare Function INSL Lib "AIOWDM" Alias "VBINSL" (Addr As UInt32, ByVal Count As UInt32, ByRef pBuf As UInt32) As UInt32
    Public Declare Function InPortDWord Lib "AIOWDM" Alias "VBInPortDWord" (ByVal Port As UInt32) As UInt32
    Public Declare Function OutPortDWord Lib "AIOWDM" Alias "VBOutPortDWord" (ByVal Port As UInt32, Value As UInt32) As UInt16

End Module
